#include <stdlib.h>
#include <Wire.h>
#include <SPI.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 64 // OLED display height, in pixels
// Declaration for an SSD1306 display connected to I2C (SDA, SCL pins)
#define OLED_RESET     -1 // Reset pin # (or -1 if sharing Arduino reset pin)
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);
#define NUMFLAKES     10 // Number of snowflakes in the animation example
#define LOGO_HEIGHT   16
#define LOGO_WIDTH    16
#define Si5351A_ADDR 0x60
#define MSNA_ADDR 26
#define MS0_ADDR 42
#define MS1_ADDR 50
#define MS2_ADDR 58
#define CLK0_CTRL 16
#define CLK1_CTRL 17
#define CLK2_CTRL 18
#define OUTPUT_CTRL 3
#define PLL_RESET 177
#define XTAL_LC 183
unsigned long freq = 10000 ;
unsigned long frequency = 28000000; //目的周波数
const unsigned long XtalFreq = 25000000; //水晶発振器の周波数
unsigned long divider;
unsigned long PllFreq;
unsigned int mult;
unsigned long l;
float f;
unsigned long num;
const unsigned long denom = 1048575;
unsigned long P1;
unsigned long P2;
unsigned long P3;
char buffer[15]={};
const int A_pin = 3; // 割り込みピン
const int B_pin = 4;
int count = 0; 

int frq[17]={700,702,704,706,708,710,712,714,716,718,720,1010,1400,1402,66,82,350};
int dataN=17 ;   // data  ↑　
void setup()
{
pinMode(8, INPUT_PULLUP);

Wire.begin(); // Arduino  Master.

Si5351_write(OUTPUT_CTRL,0xFF); //Disable Output
Si5351_write(CLK0_CTRL,0x80); //CLOCK0 Power down
Si5351_write(XTAL_LC,0x92); //Crystal Load Capasitance=8pF
divider = 900000000 / frequency;
if (divider % 2) divider--;
PLLA_set();
MS0_set();
Si5351_write(PLL_RESET,0xA0); //Reset PLLA and PLLB
Si5351_write(CLK0_CTRL,0b01001111);  // Si5351_write(CLK0_CTRL,0b01001111); //CLOCK0 Power up 8mA
Si5351_write(OUTPUT_CTRL,0xFE); //Enable CLOCK0
if(!display.begin(SSD1306_SWITCHCAPVCC, 0x3C)) { 
 Serial.println(F("SSD1306 allocation failed"));
 for(;;); // Don't proceed, loop forever
}
  display.display();
  delay(2000); // Pause for 2 seconds

  // Clear the buffer
  display.clearDisplay();
  // Draw a single pixel in white
  display.drawPixel(20, 20, WHITE);

  // Show the display buffer on the screen. You MUST call display() after
  // drawing commands to make them visible on screen!
  display.display();
  drawchar(); 
  delay(2000);

}

void loop()
{
int ps=LOW;
int fchang;
ps=digitalRead(8);
if(ps==HIGH){ 
  count++; 
  if (count>(dataN-1)){count=0;}
  set_freq();
  display.clearDisplay();
  dtostrf(frequency/4000000.0,7,3,buffer);
  display.setTextSize(1);
  display.setCursor(10, 0);  
  display.write("Center Frequency");
  display.setTextSize(2);
  display.setCursor(0,30); 
  display.write(buffer);
  display.setTextSize(1);
  display.write("   MHz");
  display.display();
  delay(1000);
  ps=LOW;
}
}

void Si5351_write(byte Reg , byte Data)
{
Wire.beginTransmission(Si5351A_ADDR);
Wire.write(Reg);
Wire.write(Data);
Wire.endTransmission();
}

void PLLA_set()
{
PllFreq = divider * frequency;
mult = PllFreq / XtalFreq;
l = PllFreq % XtalFreq;
f = l;
f *= denom;
f /= XtalFreq;
num = f;

P1 = (unsigned long)(128 * ((float)num /(float)denom));
P1 = (unsigned long)(128 * (unsigned long)mult + P1 - 512);
P2 = (unsigned long)(128 * ((float)num / (float)denom));
P2 = (unsigned long)(128 * num -denom * P2);
P3=denom;
Si5351_write(MSNA_ADDR + 0,(P3 & 0x0000FF00) >> 8); //MSNA_P3[15:8]
Si5351_write(MSNA_ADDR + 1,(P3 & 0x000000FF)); //MSNA_P3[7:0]
Si5351_write(MSNA_ADDR + 2,(P1 & 0x00030000) >> 16); //MSNA_P1[17:16]
Si5351_write(MSNA_ADDR + 3,(P1 & 0x0000FF00) >> 8); //MSNA_P1[15:8]
Si5351_write(MSNA_ADDR + 4,(P1 & 0x000000FF)); //MSNA_P1[7:0]
Si5351_write(MSNA_ADDR + 5,((P3 & 0x000F0000) >> 12) | ((P2 & 0X000F0000) >> 16)); //MSNA_P3[19:16]MSNA_P2[19:16]
Si5351_write(MSNA_ADDR + 6,(P2 & 0x0000FF00) >> 8); //MSNA_P2[15:8]
Si5351_write(MSNA_ADDR + 7,(P2 & 0x000000FF)); //MSNA_P2[7:0]
}

void MS0_set()
{
P1 = 128 * divider - 512;
P2 = 0;
P3 = 1;
Si5351_write(MS0_ADDR + 0,(P3 & 0x0000FF00) >> 8); //MS0_P3[15:8]
Si5351_write(MS0_ADDR + 1,(P3 & 0x000000FF)); //MS0_P3[7:0]
Si5351_write(MS0_ADDR + 2,(P1 & 0x00030000) >> 16); //MS0_P1[17:16]
Si5351_write(MS0_ADDR + 3,(P1 & 0x0000FF00) >> 8); //MS0_P1[15:8]
Si5351_write(MS0_ADDR + 4,(P1 & 0x000000FF)); //MS0_P1[7:0]
Si5351_write(MS0_ADDR + 5,((P3 & 0x000F0000) >> 12) | ((P2 & 0X000F0000) >> 16)); //MS0_P3[19:16]MS0_P2[19:16]
Si5351_write(MS0_ADDR + 6,(P2 & 0x0000FF00) >> 8); //MS0_P2[15:8]
Si5351_write(MS0_ADDR + 7,(P2 & 0x000000FF)); //MS0_P2[7:0]
}

void drawchar(void) {
  display.clearDisplay();

  display.setTextSize(2);      // Normal 1:1 pixel scale
  display.setTextColor(WHITE); // Draw white text
  display.setCursor(0, 0);     // Start at top-left corner
  display.cp437(true);         // Use full 256 char 'Code Page 437' font
  set_freq();
  display.clearDisplay();
  dtostrf(frequency/4000000.0,7,3,buffer);
  display.setCursor(0, 0);  
  display.write(buffer);
  display.display();
  delay(500);
  display.clearDisplay();
  display.setTextSize(1);
  display.setCursor(10, 0);  
  display.write("Center Frequency");
  display.setTextSize(2);
  display.setCursor(0,30); 
  display.write(buffer);
  display.setTextSize(1);
  display.write("   MHz");
  display.display();
  delay(500);
 
}
void testdrawcircle(void) {
  display.clearDisplay();

  for(int16_t i=0; i<max(display.width(),display.height())/2; i+=2) {
    display.drawCircle(display.width()/2, display.height()/2, i, WHITE);
    display.display();
    delay(1);
  }

  delay(2000);
}


void set_freq() {
Si5351_write(OUTPUT_CTRL,0xFF); //Disable Output
frequency = frq[count]*40000 ;
divider = 900000000 / frequency;
if (divider % 2) divider--;
PLLA_set();
MS0_set();
Si5351_write(PLL_RESET,0xA0); //Reset PLLA and PLLB
//Si5351_write(CLK0_CTRL,0b01001111);  // Si5351_write(CLK0_CTRL,0b01001111); //CLOCK0 Power up 8mA
Si5351_write(OUTPUT_CTRL,0xFE); //Enable CLOCK0

}
